#include <string.h>
#include "itemlist.h"

extern int native;
extern char *ModuleName;

char *initialize   (item_list_t list);
char *declarations (item_list_t list);
char *param_names  (item_list_t list);
char *mysprintf    (char *format, ...);

/****************************************************/
static char *const_shape = "\
ft_thread_t %s_create_in (ft_scheduler_t _sched %s)\n\
{\n\
   ft_thread_t _thread;\n\
   %s_data_t _locals = mymalloc (sizeof (struct %s_data_t));\n\
   %s\n\
   %s\n\
   return _thread;\n\
}\n\
ft_thread_t %s_create (%s)\n\
{\n\
   return %s_create_in (implicit_scheduler ()%s);\n\
}\n\
";

static char *automaton_shape = "\
_thread = ft_automaton_create (_sched,%s_fun,%s_finalize,_locals);\n\
";

static char *native_shape = "\
_thread = ft_thread_create (_sched,%s_fun,%s_finalize,_locals);\n\
pthread_detach (ft_pthread (_thread));\n\
";

static char *thread_creation (char *name)
{
   if (native) return mysprintf (native_shape,name,name);
   else return mysprintf (automaton_shape,name,name);
}

char *constructor (item_list_t paramlist)
{
   char *params = declarations(paramlist);
   char *cparams = (0 == strcmp ("",params)) ? params : mysprintf (",%s",params);

   return mysprintf (const_shape,
      ModuleName,cparams,
      ModuleName,ModuleName,
      initialize (paramlist),
      thread_creation (ModuleName),
      ModuleName,((0 == strcmp ("",params)) ? "void" : params),
      ModuleName,param_names (paramlist));
}
