#include <stdio.h>
#include <string.h>
#include "status.h"
#include "loft_sem.h"
#include "local.h"
#include "constructor.h"
#include "atom.h"

char* mysprintf(char *format, ...);
extern int run_exists;

/****************************************************/
char *ModuleName;
void set_module_name (char *name)
{
   if (0==strcmp(name,"main")) {
      ModuleName = "_main";
   } else {
      ModuleName = name;
   }
   reset_local_data_list ();   
}

/****************************************************/
static char *function_shape = "\
instruction_t %s (%s_data_t _local_vars)\n\
{\n\
    return %s;\n\
}";

static char *finalize_shape = "\
void %s_finalize (%s_data_t _local_vars)\n\
{\n\
       %s\n\
}";

static char *module_shape = "\
/*********** module %s *********/\n\
%s\n\
%s\n\
%s\n\
%s\n\
%s\n\
/**** end of module %s *********/";

/****************************************************/
static char *finalize_fun (char *atom)
{
   return mysprintf (finalize_shape,
      ModuleName,ModuleName,
      (atom ? atom : ""));
}

/****************************************************/
char *Module (item_list_t params,char *fin,item_list_t locals,char *stat)
{
   char *selector  = create_atom_selector (ModuleName);
   char *builder   = constructor (params);
   char *function  = mysprintf (function_shape,ModuleName,ModuleName,stat);

   concat_local_data (params);
   concat_local_data (locals);

   if (run_exists) {
       add_local_data ("thread_t","_run");
       run_exists = 0;
   }

   return mysprintf (module_shape,
      ModuleName,
      local_data_structure (),
      finalize_fun (fin),
      selector,
      function,
      builder,
      ModuleName);
}

/****************************************************/
static char *extern_shape = "\
%sinstruction_t %s ();\n\
thread_t %s_create ();\n";


char *ExternModule(item_list_t list)
{
   char *res = "";
   item_cell_t cell;
   if (_length_of_item_list (list) == 0) return res;
   
   cell = _first_cell (list);

   while (cell != NULL) {
      char *name = _content_of_cell (cell);
      res = mysprintf (extern_shape,res,name,name);
      cell = _next_cell (cell);
   }
   return res;   
}
